﻿'IDT1070 MCU ISP version 1.0

Imports System
Imports System.Threading
Imports System.IO.Ports
Imports System.ComponentModel


Public Class IDT_1070
    Dim command As Byte
    Dim myPort As Array
    Dim tx_buffer(256) As Byte
    Dim rx_buffer(256) As Byte
    Dim rev_data As UInt16
    Dim rev_data_h As Byte
    Dim rev_data_l As Byte
    Dim rev_data_cal As UInt16
    Dim crc_cal_h As Byte
    Dim crc_cal_l As Byte


    Delegate Sub SetTextCallBack(ByVal [text] As String)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' myPort = IO.Ports.SerialPort.GetPortNames()
        'portComboBox.Items.AddRange(myPort)
        power_on_M.Text = 0
        power_on_S.Text = 15
        power_off_M.Text = 0
        power_off_S.Text = 15
        command_text.Text = ""
        outputTextBox.Text = ""

    End Sub

    Private Sub initButton_Click(sender As Object, e As EventArgs) Handles initButton.Click
        'SerialPort1.PortName = portComboBox.Text
        'SerialPort1.BaudRate = baudComboBox.Text
        SerialPort1.BaudRate = 19200
        'SerialPort1.ReceivedBytesThreshold = 1
        SerialPort1.Open()

        initButton.Enabled = False
        closeButton.Enabled = True
        get_firmware_version.Enabled = True
        set_power_on_delay.Enabled = True
        set_power_off_delay.Enabled = True
        get_status_button.Enabled = True

    End Sub
    Private Sub closeButton_Click(sender As Object, e As EventArgs) Handles closeButton.Click
        SerialPort1.Close()
        initButton.Enabled = True
        closeButton.Enabled = False
        get_firmware_version.Enabled = False
        set_power_on_delay.Enabled = False
        set_power_off_delay.Enabled = False
        get_status_button.Enabled = False
    End Sub
    'receive MCU comport Data & print to outputTextBox
    Private Sub ReceivedText(ByVal [Text] As String)
        If Me.outputTextBox.InvokeRequired Then
            Dim x As New SetTextCallBack(AddressOf ReceivedText)
            Me.Invoke(x, New Object() {(Text)})
        Else
            Me.outputTextBox.Text &= [Text]
        End If
    End Sub
    Private Sub ReceivedText_status_out(ByVal [Text] As String)
        If Me.status_out.InvokeRequired Then
            Dim x As New SetTextCallBack(AddressOf ReceivedText_status_out)
            Me.Invoke(x, New Object() {(Text)})
        Else
            Me.status_out.Text &= [Text]
        End If
    End Sub
    'CRC16 calculate
    Function calc_crc(data As Byte(), n As UInt16, start As UInt16) As UInt16
        Dim I As UInt16, q As UInt16, c As UInt16, crcval As UInt16

        crcval = start
        For I = 0 To n - 1
            c = Convert.ToUInt16(data(I) And &HFF)
            q = Convert.ToUInt16((crcval Xor c) And &HF)
            crcval = Convert.ToUInt16((crcval >> 4) Xor (q * &H1081))
            q = Convert.ToUInt16((crcval Xor (c >> 4)) And &HF)
            crcval = Convert.ToUInt16((crcval >> 4) Xor (q * &H1081))
        Next

        Return crcval
    End Function
    'button for get firmware version
    Private Sub get_firmware_version_Click(sender As Object, e As EventArgs) Handles get_firmware_version.Click
        get_firmware_version.Enabled = False
        set_power_on_delay.Enabled = False
        set_power_off_delay.Enabled = False
        get_status_button.Enabled = False


        For I = 0 To 255
            tx_buffer(I) = 0
        Next


        tx_buffer(0) = &HFF
        tx_buffer(1) = &HEE
        tx_buffer(2) = &H0
        tx_buffer(3) = &H1

        rev_data = calc_crc(tx_buffer, &H4, &H0)


        tx_buffer(4) = rev_data And &HFF
        tx_buffer(5) = (rev_data >> 8) And &HFF


        SerialPort1.Write(tx_buffer, 0, 6)

        command_text.Text = ""
        'wait for mcu return
        Thread.Sleep(2000)
        Timer1.Enabled = True

    End Sub
    'button for power on timer setting
    Private Sub set_power_on_delay_Click(sender As Object, e As EventArgs) Handles set_power_on_delay.Click
        get_firmware_version.Enabled = False
        set_power_on_delay.Enabled = False
        set_power_off_delay.Enabled = False
        get_status_button.Enabled = False

        For I = 0 To 255
            tx_buffer(I) = 0
        Next


        tx_buffer(0) = &HFF
        tx_buffer(1) = &HEE
        tx_buffer(2) = &H2
        tx_buffer(3) = &H4

        tx_buffer(4) = power_on_M.Text And &HFF
        tx_buffer(5) = power_on_S.Text And &HFF

        rev_data = calc_crc(tx_buffer, &H6, &H0)
        tx_buffer(6) = rev_data And &HFF
        tx_buffer(7) = (rev_data >> 8) And &HFF


        SerialPort1.Write(tx_buffer, 0, 8)

        'wait for mcu return
        Thread.Sleep(2000)
        Timer1.Enabled = True

    End Sub
    'button for power off timer setting
    Private Sub set_power_off_delay_Click(sender As Object, e As EventArgs) Handles set_power_off_delay.Click
        get_firmware_version.Enabled = False
        set_power_on_delay.Enabled = False
        set_power_off_delay.Enabled = False
        get_status_button.Enabled = False

        For I = 0 To 255
            tx_buffer(I) = 0
        Next


        tx_buffer(0) = &HFF
        tx_buffer(1) = &HEE
        tx_buffer(2) = &H2
        tx_buffer(3) = &H5

        tx_buffer(4) = power_off_M.Text And &HFF
        tx_buffer(5) = power_off_S.Text And &HFF

        rev_data = calc_crc(tx_buffer, &H6, &H0)
        tx_buffer(6) = rev_data And &HFF
        tx_buffer(7) = (rev_data >> 8) And &HFF


        SerialPort1.Write(tx_buffer, 0, 8)

        'wait for mcu return
        Thread.Sleep(2000)
        Timer1.Enabled = True

    End Sub
    'button for get status(power on timer setting value && power off timer setting value )

    Private Sub get_status_button_Click(sender As Object, e As EventArgs) Handles get_status_button.Click
        get_firmware_version.Enabled = False
        set_power_on_delay.Enabled = False
        set_power_off_delay.Enabled = False
        get_status_button.Enabled = False

        For I = 0 To 255
            tx_buffer(I) = 0
        Next


        tx_buffer(0) = &HFF
        tx_buffer(1) = &HEE
        tx_buffer(2) = &H0
        tx_buffer(3) = &H10

        rev_data = calc_crc(tx_buffer, &H4, &H0)


        tx_buffer(4) = rev_data And &HFF
        tx_buffer(5) = (rev_data >> 8) And &HFF


        SerialPort1.Write(tx_buffer, 0, 6)

        Thread.Sleep(2000)
        Timer1.Enabled = True

    End Sub
    Public Function AsciiStringToHexString(ByVal asciiString As String) As Array
        Dim ascii() As Byte = System.Text.Encoding.Default.GetBytes(asciiString)
        Dim count As Integer = ascii.Length
        Dim hexArray(count - 1) As String
        For idx As Integer = 0 To count - 1
            hexArray(idx) = ascii(idx).ToString("x2")
        Next
        Return hexArray 'String.Join(" ", hexArray)  
    End Function
    '
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        command_text.Text = ""
        status_out.Text = ""
        outputTextBox.Clear()


        If SerialPort1.BytesToRead = 0 Then
            command_text.Text = "No Data Receive"
        Else
            SerialPort1.Read(rx_buffer, 0, 16)




            If (rx_buffer(3) = 1) Then
                rev_data_cal = calc_crc(rx_buffer, &H7, &H0)
                crc_cal_h = (rev_data_cal >> 8) And &HFF
                crc_cal_l = rev_data_cal And &HFF

                For I = 0 To (4 + 2 + rx_buffer(2) - 1)
                    ReceivedText(rx_buffer(I) & vbCr)
                Next



                If ((crc_cal_l = (rx_buffer(7))) And (crc_cal_h = (rx_buffer(8)))) Then
                    command_text.Text = "GET  FIRMWARE  VERSION"
                    major_version.Text = rx_buffer(4)
                    minor_version.Text = rx_buffer(5)
                    build_version.Text = rx_buffer(6)
                Else
                    major_version.Text = ""
                    minor_version.Text = ""
                    build_version.Text = ""
                    command_text.Text = "CRC  ERROR"
                End If
            ElseIf (rx_buffer(3) = 4) Then
                rev_data_cal = calc_crc(rx_buffer, 4, 0)
                crc_cal_h = (rev_data_cal >> 8) And &HFF
                crc_cal_l = rev_data_cal And &HFF
                For I = 0 To (4 + 2 + rx_buffer(2) - 1)
                    ReceivedText(rx_buffer(I) & vbCr)
                Next

                If ((crc_cal_l = (rx_buffer(4))) And (crc_cal_h = (rx_buffer(5)))) Then
                    command_text.Text = "SET  POWER ON DELAY"
                Else
                    command_text.Text = "CRC  ERROR"
                End If
            ElseIf (rx_buffer(3) = 5) Then
                rev_data_cal = calc_crc(rx_buffer, 4, 0)
                crc_cal_h = (rev_data_cal >> 8) And &HFF
                crc_cal_l = rev_data_cal And &HFF
                For I = 0 To (4 + 2 + rx_buffer(2) - 1)
                    ReceivedText(rx_buffer(I) & vbCr)
                Next

                If ((crc_cal_l = (rx_buffer(4))) And (crc_cal_h = (rx_buffer(5)))) Then
                    command_text.Text = "SET  POWER OFF DELAY"
                Else
                    command_text.Text = "CRC  ERROR"
                End If
            ElseIf (rx_buffer(3) = 16) Then
                rev_data_cal = calc_crc(rx_buffer, 8, 0)
                crc_cal_h = (rev_data_cal >> 8) And &HFF
                crc_cal_l = rev_data_cal And &HFF
                For I = 0 To (4 + 2 + rx_buffer(2) - 1)
                    ReceivedText(rx_buffer(I) & vbCr)
                Next


                If ((crc_cal_l = (rx_buffer(8))) And (crc_cal_h = (rx_buffer(9)))) Then
                    command_text.Text = "GET  STATUS"

                    ReceivedText_status_out("POWER ON DELAY  =" & (rx_buffer(4)).ToString & "M " & (rx_buffer(5)).ToString & "S " & vbCr)
                    ReceivedText_status_out("POWER OFF DELAY =" & (rx_buffer(6)).ToString & "M " & (rx_buffer(7)).ToString & "S " & vbCr)

                    power_on_M.Text = rx_buffer(4) And &HFF
                    power_on_S.Text = rx_buffer(5) And &HFF

                    power_off_M.Text = rx_buffer(6) And &HFF
                    power_off_S.Text = rx_buffer(7) And &HFF
                Else
                    command_text.Text = "CRC  ERROR"
                End If
            End If
        End If


        For I = 0 To 255
            rx_buffer(I) = 0
        Next

        get_firmware_version.Enabled = True
        set_power_on_delay.Enabled = True
        set_power_off_delay.Enabled = True
        get_status_button.Enabled = True

        Timer1.Enabled = False
    End Sub











End Class
